scala.tools.nsc.backend.icode

# Primitives

###
Related Doc: package icode

#### trait Primitives extends AnyRef

Self Type
  ICodes
Source
  Primitives.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
ICodes, icodes
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Primitives
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Type Members

1. #### case class Arithmetic (op: ICodes.ArithmeticOp, kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

2. #### class ArithmeticOp extends AnyRef

   This class represents an arithmetic operation.

3. #### case class ArrayLength (kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

4. #### case class Comparison (op: ICodes.ComparisonOp, kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

5. #### class ComparisonOp extends AnyRef

   This class represents a comparison operation.

6. #### case class Conversion (src: ICodes.TypeKind, dst: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

7. #### case class Logical (op: ICodes.LogicalOp, kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

8. #### class LogicalOp extends AnyRef

   This class represents a logical operation.

9. #### case class Negation (kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

10. #### class Primitive extends AnyRef

    This class represents a primitive operation.

11. #### class PrimitivePrinter extends AnyRef

    Pretty printer for primitives

12. #### case class Shift (op: ICodes.ShiftOp, kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

13. #### class ShiftOp extends AnyRef

    This class represents a shift operation.

14. #### case class StringConcat (el: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

15. #### case class Test (op: ICodes.TestOp, kind: ICodes.TypeKind, zero: Boolean) extends ICodes.Primitive with Product with Serializable

16. #### sealed abstract class TestOp extends AnyRef

    This class represents a test operation.

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Primitives to any2stringadd[Primitives] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Primitives, B)

   Implicit information
     This member is added by an implicit conversion from Primitives to ArrowAssoc[Primitives] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object ADD extends ICodes.ArithmeticOp with Product with Serializable

   An arithmetic addition operation

7. #### object AND extends ICodes.LogicalOp with Product with Serializable

   A bitwise AND operation

8. #### object ASR extends ICodes.ShiftOp with Product with Serializable

   An arithmetic shift to the right

9. #### object CMP extends ICodes.ComparisonOp with Product with Serializable

   A comparison operation with no default for NaNs

10. #### object CMPG extends ICodes.ComparisonOp with Product with Serializable

    A comparison operation with +1 default for NaNs

11. #### object CMPL extends ICodes.ComparisonOp with Product with Serializable

    A comparison operation with -1 default for NaNs

12. #### object DIV extends ICodes.ArithmeticOp with Product with Serializable

    An arithmetic division operation

13. #### object EQ extends ICodes.TestOp with Product with Serializable

    An equality test

14. #### object EndConcat extends ICodes.Primitive with Product with Serializable

    type: (buf) => STR jvm : It should turn the StringBuffer into a String.

15. #### object GE extends ICodes.TestOp with Product with Serializable

    A greater-than-or-equal test

16. #### object GT extends ICodes.TestOp with Product with Serializable

    A greater-than test

17. #### object LE extends ICodes.TestOp with Product with Serializable

    A less-than-or-equal test

18. #### object LSL extends ICodes.ShiftOp with Product with Serializable

    A logical shift to the left

19. #### object LSR extends ICodes.ShiftOp with Product with Serializable

    A logical shift to the right

20. #### object LT extends ICodes.TestOp with Product with Serializable

    A less-than test

21. #### object MUL extends ICodes.ArithmeticOp with Product with Serializable

    An arithmetic multiplication operation

22. #### object NE extends ICodes.TestOp with Product with Serializable

    A non-equality test

23. #### object NOT extends ICodes.ArithmeticOp with Product with Serializable

    Bitwise negation.

24. #### object OR extends ICodes.LogicalOp with Product with Serializable

    A bitwise OR operation

25. #### object REM extends ICodes.ArithmeticOp with Product with Serializable

    An arithmetic remainder operation

26. #### object SUB extends ICodes.ArithmeticOp with Product with Serializable

    An arithmetic subtraction operation

27. #### object StartConcat extends ICodes.Primitive with Product with Serializable

    Signals the beginning of a series of concatenations.

    Signals the beginning of a series of concatenations. On the JVM platform, it should create a new StringBuffer

28. #### object XOR extends ICodes.LogicalOp with Product with Serializable

    A bitwise XOR operation

29. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

30. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

31. #### def ensuring(cond: (Primitives) ⇒ Boolean, msg: ⇒ Any): Primitives

    Implicit information
      This member is added by an implicit conversion from Primitives to Ensuring[Primitives] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

32. #### def ensuring(cond: (Primitives) ⇒ Boolean): Primitives

    Implicit information
      This member is added by an implicit conversion from Primitives to Ensuring[Primitives] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

33. #### def ensuring(cond: Boolean, msg: ⇒ Any): Primitives

    Implicit information
      This member is added by an implicit conversion from Primitives to Ensuring[Primitives] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

34. #### def ensuring(cond: Boolean): Primitives

    Implicit information
      This member is added by an implicit conversion from Primitives to Ensuring[Primitives] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

35. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

36. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

37. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

38. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Primitives to StringFormat[Primitives] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

39. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

40. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

41. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

42. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

43. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

44. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

45. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

46. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

47. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

48. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

49. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

50. #### def →[B](y: B): (Primitives, B)

    Implicit information
      This member is added by an implicit conversion from Primitives to ArrowAssoc[Primitives] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Primitives to any2stringadd[Primitives]

### Inherited by implicit conversion StringFormat from Primitives to StringFormat[Primitives]

### Inherited by implicit conversion Ensuring from Primitives to Ensuring[Primitives]

### Inherited by implicit conversion ArrowAssoc from Primitives to ArrowAssoc[Primitives]

### Ungrouped